import java.util.*;
import java.io.*;
import java.net.*;

public class WebServer implements Runnable {
  ServerSocket server = null;
  String  root;
  String[] map ={"jpg=image/jpeg", "gif=image/gif", "zip=application/zip", "pdf=application/pdf", "xls=application/vnd.ms-excel", "ppt=application/vnd.ms-powerpoint", "doc=application/msword", "htm=text/html", "html=text/html", "css=text/plain", "vbs=text/plain", "js=text/plain", "txt=text/plain", "java=text/plain"};
  FileWriter log = new FileWriter("WebServer.log", true);

  public static void main(String args[]) throws Exception {
    int serverPort = 80;
    String rootPath = "";
    if (args.length >= 2) serverPort = Integer.parseInt(args[1]);
    if (args.length >= 1) rootPath = args[0];
    new WebServer(serverPort, rootPath);
  }
	
  public WebServer(int pPort, String pRoot) throws IOException {
    server = new ServerSocket(pPort); // إ ServerSocket æ port (w] 80).
    File rootDir = new File(pRoot);
    root = rootDir.getCanonicalPath();
    System.out.println("port="+pPort+" root="+root);
    run();
  }
    
  public void run() {
    try {
      Socket socket = server.accept();      // ssuC`N: accept() O@ӵݫIsA|@즳suiӤ~C
      Thread service = new Thread(this);    // إߤ@ӷs WebServer C
      service.start();                      // ҰʥHHKBzU@ӽШDC
      DataOutputStream out = new DataOutputStream(socket.getOutputStream()); // oǰeƪXɡC
      DataInputStream in = new DataInputStream(socket.getInputStream());     // oƪJɡC
      String request = request(in);         // ŪsǨӪШDTC
      response(socket, request, out);               // ^T誺sC
      socket.close();                       // ӳsuC
    } catch (Exception e) { e.printStackTrace(); }
  }
	
  String request(DataInputStream in) {
    System.out.println("=========request()===========");
    String request = "";
    try {
      // ŪĤ@Ӫťզ欰AoOYTC
      while (true) {
        String line = in.readLine();
        if (line == null) break;
        request += line+"\r\n";
        if (line.length() == 0) break;
      }
      System.out.println(request);
    } catch (Exception e) {}
    return request;
  }
  
  public static String innerText(String pText, String beginMark, String endMark) {
    int beginStart = pText.indexOf(beginMark);
    if (beginStart < 0) return null;
    int beginEnd = beginStart+beginMark.length();
    int endStart = pText.indexOf(endMark, beginEnd);
    if (endStart < 0) return null;
    return pText.substring(beginEnd, endStart);
  }

  void response(Socket socket, String request, DataOutputStream out) throws Exception {
    System.out.println("========response()==========");
    try {
      String path = innerText(request, "GET ", "HTTP/").trim(); // oɮ׸| : GET C
      path = java.net.URLDecoder.decode(path, "UTF-8");  	// Nɮ׸|ѽXH Unicode 覡ѽXC
      log.write((new Date()).toString()+"\t,"+socket.getRemoteSocketAddress()+"\t,"+path+"\r\n");
      log.flush();
      String fullPath = root+path;                       	// N|ର|C
      if (fullPath.indexOf(".")<0) fullPath += "/index.htm";
      File file = new File(fullPath);                    	// }ɮסC
      if (!file.exists()) throw new Exception("File not found !");
      output(out, "HTTP/1.0 200 OK");                   	// Ǧ^\TC
      output(out, "Content-Type: "+type(fullPath));      	// Ǧ^ɮC
      output(out, "Content-Length: " + file.length());   	// Ǧ^eסC
      output(out, "");                                  	// ŦNYqC
      // H϶^ɮסC
      byte[] buffer = new byte[4096];
      FileInputStream is = new FileInputStream(fullPath);
      while (true) {
        int len = is.read(buffer);
        out.write(buffer, 0, len);
        if (len < 4096) break;
      }
    } catch (Exception e) { // AǦ^~TC
      output(out, "HTTP/1.0 404 " + e.getMessage());
//      output(out, "Content-Type: text/html");
      output(out, "");
    }
    out.flush();
  }
  
  String type(String path) {
    String type="*/*";
    path = path.toLowerCase();
    for (int i=0; i<map.length; i++) {
      String[] tokens = map[i].split("=");
      String ext = tokens[0], mime = tokens[1];
      if (path.endsWith("."+ext)) type = mime;
    }
    return type;
  }
  
  void output(DataOutputStream out, String str) throws Exception {
    out.writeBytes(str+"\r\n");
    System.out.println(str);
  }
}